Day36 贪心算法Part03

LC1005 K次取反后最大化的数组和(未掌握)

  1. 未掌握分析:贪心思维不够
  2. 贪心思路:
    • 局部最优:让绝对值大的负数变为正数,当前数值达到最大,
    • 整体最优:整个数组和达到最大。
    • 如果将负数都转变为正数了,K依然大于0,此时的问题是一个有序正整数序列,如何转变K次正负,让 数组和 达到最大。
      • 局部最优:只找数值最小的正整数进行反转,当前数值和可以达到最大,全局最优:整个 数组和 达到最大。
  3. 代码.

LC134加油站(未掌握)

  1. 暴力方法:遍历每一个加油站为起点的情况,模拟一圈
    • 因为涉及循环一圈,因此比较麻烦,for循环适合模拟从头到尾的遍历,而while循环适合模拟环形遍历,要灵活使用while
    • 时间复杂度O(N^2)
  2. 代码
  3. 贪心思路
    • 如果总油量减去总消耗大于等于零那么一定可以跑完一圈,说明 各个站点的加油站 剩油量resti相加一定是大于等于零的
    • 每个加油站的剩余量resti为gasi - costi
    • i从0开始累加resti,和记为curSum,一旦curSum小于零,说明0, i区间都不能作为起始位置,因为这个区间选择任何一个位置作为起点,到i这里都会断油,那么起始位置从i+1算起,再从0计算curSum。
  4. 代码
    • totalSum是用来根据总油量减去总消耗是否大于等于零做出判断的

LC135分发糖果(未掌握)

  1. 思路:
    • 确定一边之后,再确定另一边,例如比较每一个孩子的左边,然后再比较右边,如果两边一起考虑一定会顾此失彼。
    • 先确定右边评分大于左边的情况(也就是从前向后遍历)
      • 局部最优:只要右边评分比左边大,右边的孩子就多一个糖果,全局最优:相邻的孩子中,评分高的右孩子获得比左边孩子更多的糖果
      • 如果ratingsi > ratingsi - 1 那么candyVeci = candyVeci - 1 + 1
    • 再确定左孩子大于右孩子的情况(从后向前遍历)
      • 为什么不从前向后遍历,因为ratingi+1与ratingi的比较 要利用上 ratingi+1与ratingi+2的比较结果,所以要从后向前遍历
      • 如果 ratingsi > ratingsi + 1,此时candyVeci(第i个小孩的糖果数量)就有两个选择了,一个是candyVeci + 1 + 1(从右边这个加1得到的糖果数量),一个是candyVeci(之前比较右孩子大于左孩子得到的糖果数量),取最大值
  2. 代码
相关推荐
夕除7 分钟前
redis--dict rehash
算法·哈希算法
云上先途122 分钟前
Agent 轨迹数据一般包含哪些内容,加工的核心目标是什么?
人工智能·算法·机器学习
佳木逢钺1 小时前
从火灾模拟到系统热寂:一个双非运维如何用零 GPU 推导出多智能体系统的终极死锁
人工智能·python·算法·多智能体
垆边人似月.1 小时前
网格最小代价路径,总代价不超过 budget
算法
虚无的纽扣1 小时前
【力扣刷题】第五天:将 x 减到 0 的最小操作数、最大连续1的个数 III
算法·leetcode·职场和发展
C++ 老炮儿的技术栈1 小时前
char 造成的数据溢出
linux·服务器·c语言·c++·算法·c
sqc233sqc1 小时前
第 J8 周:ResNeXt-50 算法解析
人工智能·算法
hanlin0311 小时前
刷题笔记:力扣第32题-最长有效括号
笔记·算法·leetcode
All for pursuit.11 小时前
【动态规划-21】312.戳气球
数据结构·c++·算法·leetcode·动态规划
碧海银沙音频科技研究院14 小时前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法